<?php

declare(strict_types=1);

namespace Dedi\SyliusMailAdminPlugin\EventListener\MailAdmin;

use Dedi\SyliusMailAdminPlugin\Event\DediMailAdminEvent;
use Sylius\Bundle\CoreBundle\Mailer\Emails;
use Sylius\Component\Core\Model\OrderInterface;
use Symfony\Bundle\FrameworkBundle\Routing\Router;
use Symfony\Component\Routing\RouterInterface;

class OrderConfirmationPreRendererListener
{
    private RouterInterface $router;

    public function __construct(RouterInterface $router)
    {
        $this->router = $router;
    }

    public function __invoke(DediMailAdminEvent $event): DediMailAdminEvent
    {
        if (!in_array($event->getEmail()->getCode(), [Emails::ORDER_CONFIRMATION, Emails::ORDER_CONFIRMATION_RESENT])) {
            return $event;
        }

        $data = $event->getData();

        /** @var OrderInterface $order */
        $order = $data['order'];

        $data['orderUrl'] = $this->router->generate('sylius_shop_order_show', [
            'tokenValue' => $order->getTokenValue(),
        ], Router::ABSOLUTE_URL);

        $event->setData($data);

        return $event;
    }
}
